unit PluginUnit;

interface
const
    { return values }
    RE_SUCCESS = 1;
    RE_IMPORT_COMPLETED = 2;
    RE_ERROR = 3;
    RE_USER_CANCELED = 4;

    { plugin capabilities }
    PC_NO_CAPS = 0;

    { import capabilities }
    PI_IMPORT_UTF8 = 1;
	PI_IMPORT_ANSI = 2;

    { export capabilities }
    PE_EXPORT_UTF8 = 1;

    { text data types }
    TD_TEXT = 0;
    TD_RTF = 1;
    TD_RVF = 2;

    { Sensitivity values }
    SE_NORMAL = 0;
    SE_PERSONAL = 1;
    SE_PRIVATE = 2;
    SE_CONFIDENTIAL = 3;
    
    { Priority values }
    PT_LOW = 0;
    PT_NORMAL = 1;
    PT_HIGH = 2;

    { Custom column types }
    CT_TEXT = 0;
    CT_NUMBER = 1;
    CT_CURRENCY = 2;
    CT_YES_NO = 3;
    CT_POPUP_LIST = 4;
    CT_CATEGORY = 5;
    CT_DATE_TIME = 6;

    { CT_NUMBER formats }
    NF_INTEGER = 0;
    NF_FRACTIONAL = 1;

    { CT_YES_NO formats }
    YF_YES_NO = 0;
    YF_TRUE_FALSE = 1;
    YF_ON_OFF = 2;
    YF_ICON = 3;

    { Custom column alignments }
    CA_LEFT = 0;
    CA_RIGHT = 1;
    CA_CENTER = 2;

    { Memory request options }
    MR_TEXT_DATA = 1;
    MR_EMBEDDED_FILE_DATA = 2;

    { Memory request return values }
    MV_ERROR = 0;
    MV_SUCCESS = 1;

type TPluginInfo = record
    Version,
    PluginName : array[0..255] of AnsiChar;
    Description : array[0..1000] of AnsiChar;
    Author,
    Copyright : array[0..255] of AnsiChar;
    ImportCaps,
    ExportCaps,
    ImportTextFormat,
    ExportTextFormat : integer;
    FileExt : array[0..50] of AnsiChar;
    FileExtDescription : array[0..255] of AnsiChar;
    end;

    PPluginInfo = ^TPluginInfo;

type TCustomColumn = record
    Caption : array[0..255] of AnsiChar;
    ColType,
    Format : integer;
    Values : array[0..5000] of AnsiChar;
    Alignment,
    Width,
    Visible : integer;
    end;

    PCustomColumn = ^TCustomColumn;

type TDocument = record
    Level : integer;
    Title : array[0..255] of AnsiChar;
    Sensitivity : integer;
    Priority : integer;
    Comment : array[0..1024] of AnsiChar;
    Tags : array[0..1024] of AnsiChar;
    Link : array[0..255] of AnsiChar;
    ColumnValues : array[0..10000] of AnsiChar;
    StateIcon: integer;
    DateCreated : array[0..19] of AnsiChar;
    DateModified : array[0..19] of AnsiChar;
    DateStarted : array[0..19] of AnsiChar;
    DateDue : array[0..19] of AnsiChar;
    DateCompleted : array[0..19] of AnsiChar;
    DateReminder : array[0..19] of AnsiChar;
    PercentCompleted : integer;
    Id : integer; // ignored on import

    TextData : PAnsiChar;
    TextDataSize : integer;

    EmbeddedFileName : array[0..255] of AnsiChar;
    EmbeddedFileData : PAnsiChar;
    EmbeddedFileDataSize : integer;
    end;

    PDocument = ^TDocument;

type
    TMemoryRequestProc = function(document : PDocument; targetMemory, newMemorySize : integer) : integer; stdcall;

implementation
begin

end.
