//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>

#pragma hdrstop

#include <stdio.h>
#include <SysUtils.hpp>

#include "..\..\Header Files\PluginHeader.h"
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------

FILE* importFile;
FILE* exportFile;

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
    return 1;
}

extern "C" int __export __stdcall GetPluginInfo(TPluginInfo* info)
{
StrCopy(info->Version, "1.0\0");
StrCopy(info->PluginName, "Tab-intended files (C++ Sample)\0");
StrCopy(info->Description, "Sample plugin written in Borland C++, which imports from and exports to tab-intended text files\0");
StrCopy(info->Author, "Milenix Software Ltd.\0");
StrCopy(info->Copyright, "Copyright (c) 2007 Milenix Software Ltd.\0");
info->ImportCaps = PI_IMPORT_UTF8;
info->ExportCaps = PE_EXPORT_UTF8;
info->ImportTextFormat = TD_TEXT;
info->ExportTextFormat = TD_TEXT;
StrCopy(info->FileExt, ".txt\0");
StrCopy(info->FileExtDescription, "Tab-intended text files (*.txt)\0");

return RE_SUCCESS;
}

/* Import section */

extern "C" int __export __stdcall BeginImportSession(char* fileName, HWND appWindow, HINSTANCE appInstance)
{
importFile = fopen(fileName, "r");

if(!importFile)
    {
    return RE_ERROR;
    }

return RE_SUCCESS;
}

extern "C" int __export __stdcall ImportDocument(TDocument* document, TMemoryRequestProc memoryRequestProc)
{
if(feof(importFile))
    {
    return RE_IMPORT_COMPLETED;
    }

char line[256];
strset(line, '\0');

// read until non-blank line is found
do
    {
    fgets(line, 255, importFile);
    }
while(line[0] == '\0');

// remove new line character
if(line[StrLen(line) - 1] == '\n')
    {
    line[StrLen(line) - 1] = '\0';
    }

int level = 0;
int i = 0;

while(line[i] == '\t')
    {
    ++level;
    ++i;
    }

char title[256];
StrCopy(title, &line[level]);

if(Trim(AnsiString(title)).IsEmpty())
    {
    return RE_IMPORT_COMPLETED;
    }

document->Level = level;
StrCopy(document->Title, title);

return RE_SUCCESS;
}


extern "C" int __export __stdcall EndImportSession()
{
fclose(importFile);

return RE_SUCCESS;
}

/* export section */

extern "C" int __export __stdcall BeginExportSession(char* fileName, HWND appWindow, HINSTANCE appInstance)
{
// create export file
exportFile = fopen(fileName, "w");

if(!exportFile)
    {
    return RE_ERROR;
    }

return RE_SUCCESS;
}


extern "C" int __export __stdcall ExportDocument(TDocument* document)
{
// create line beginning with tab characters equal to the document level
char* line = new char[document->Level + StrLen(document->Title) + 2];
for(int i = 0; i < document->Level; i++)
    {
    line[i] = '\t';
    }

StrCopy(&line[document->Level], document->Title);
line[StrLen(line)] = '\n';
fputs(line, exportFile);

return RE_SUCCESS;
}


extern "C" int __export __stdcall EndExportSession()
{
fclose(exportFile);

return RE_SUCCESS;
}
//---------------------------------------------------------------------------
 